/* SPDX-License-Identifier: GPL-2.0 OR Linux-OpenIB */
/* Copyright (c) 2019 Mellanox Technologies. */

#ifndef MLX5_NVMF_H
#define MLX5_NVMF_H

#include <linux/mlx5/driver.h>

struct mlx5_be_ctrl_attr {
	u32	cq_page_offset;
	u32	sq_page_offset;
	u8	cq_log_page_size;
	u8	sq_log_page_size;
	u16	initial_cqh_db_value;
	u16	initial_sqt_db_value;
	u8	log_cmd_timeout_us;
	u64	cqh_dbr_addr;
	u64	sqt_dbr_addr;
	u64	cq_pas;
	u64	sq_pas;
};

struct mlx5_ns_attr {
	u32	frontend_namespace;
	u32	backend_namespace;
	u16	lba_data_size;
	u16	backend_ctrl_id;
};

struct mlx5_core_nvmf_be_ctrl {
	int			id;
};

int mlx5_core_create_nvmf_backend_ctrl(struct mlx5_core_dev *dev,
				       struct mlx5_core_srq *srq,
				       struct mlx5_core_nvmf_be_ctrl *ctrl,
				       struct mlx5_be_ctrl_attr *in);

int mlx5_core_destroy_nvmf_backend_ctrl(struct mlx5_core_dev *dev,
					struct mlx5_core_srq *srq,
					struct mlx5_core_nvmf_be_ctrl *ctrl);

int mlx5_core_attach_nvmf_ns(struct mlx5_core_dev *dev,
			     struct mlx5_core_srq *srq,
			     struct mlx5_core_nvmf_be_ctrl *ctrl,
			     struct mlx5_ns_attr *attr_in);

int mlx5_core_detach_nvmf_ns(struct mlx5_core_dev *dev,
			     struct mlx5_core_srq *srq,
			     struct mlx5_core_nvmf_be_ctrl *ctrl,
			     u32 frontend_nsid);

#endif /* MLX5_NVMF_H */
